/* Headerfile for ShowPicasso
** File: ShowPicasso.h
*/

#include <stdio.h>
#include <clib/asl_protos.h>
#include <clib/dos_protos.h>
#include <clib/exec_protos.h>
#include <clib/icon_protos.h>
#include <clib/iffparse_protos.h>
#include <clib/intuition_protos.h>
#include <clib/locale_protos.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include <exec/exec.h>
#include <exec/libraries.h>
#include <graphics/modeid.h>
#include <graphics/view.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <intuition/screens.h>
#include <libraries/asl.h>
#include <libraries/iffparse.h>
#include <utility/tagitem.h>
#include <workbench/startup.h>
#include <vilintuisup/vilintuisup.h>
#include <vilintuisup/screenmode.h>
#include <iffp/iff.h>
#include <iffp/ilbm.h>

#define  WSig SIGBREAKF_CTRL_C | (1 << w->UserPort->mp_SigBit)
#define  LIBRARY_MIN 37L

/* Bits for IFFSTATE */

#define  BMHDFLG 0x0001   /* BMHD Chunk gefunden */
#define  CAMGFLG 0x0002   /* CAMG Chunk gefunden */
#define  CMAPFLG 0x0004   /* CMAP Chunk gefunden */
#define  RGB8FLG 0x2000   /* Flag fr IFF RGB8   */
#define  RGBNFLG 0x4000   /* Flag fr IFF RGBN   */
#define  ILBMFLG 0x8000   /* Flag fr IFF ILBM   */

/* Bits for USERFLGS */

#define  UFLG_NOCENTER 0x0001 /* Flag zur Zentrierung des Screens */
#define  UFLG_BEHIND   0x0002 /* Flag fr Bildaufbau im Hintergrund */
#define  UFLG_AUTO16   0x0004 /* Flag zur automatischen Umschaltung auf 16 Bit */
#define  UFLG_NOSCROLL 0x0008 /* Flag fr Autoscroll-Screen */
#define  UFLG_QUIET    0x0010 /* Quietflag bei Start vom Cli */
#define  PFLG_TRUECLR  0x0100 /* Flag fr Truecolor 24 Bit */
#define  PFLG_TC15BIT  0x1000 /* Flag fr Truecolor Umrechnung auf 15 Bit */
#define  PFLG_TC16BIT  0x2000 /* Flag fr Truecolor Umrechnung auf 16 Bit */

#define  ERR_CHKE2T  1L   /* Chunk existiert zweimal   */   
#define  ERR_MGLIFF  2L   /* Fehler in  IFF ILBM File  */
#define  ERR_PRSIFF  3L   /* Error bei ParseIFF()      */ 
#define  ERR_NOSCR   4L   /* Screen nicht verfgbar    */
